/****************************************************************************
*
*   Module: PASSWORD
*
****************************************************************************/

#include "main.h"

/* #define DBSTUB */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <penright.h>
#include "password.h"

#define BACKSPACE 0X08 
#define FIELDSIZE 12

char pwBuf[FIELDSIZE];
WORD col=1;

BOOLEAN HandPasswordEntry(EVENTTYPE far *event, WORD far *error);

BOOLEAN HandPasswordEntry(EVENTTYPE far *event, WORD far *error)
{
    BOOLEAN bsFlag = FALSE;
    BOOLEAN okFlag = FALSE;    

    if(col<(FIELDSIZE-1) || (event->data1==backspace_BTN))
    {
      switch(event->data1)
      {
        case one_BTN:
           strcat(pwBuf,"1");
           break;
        case two_BTN:
           strcat(pwBuf,"2");
           break;
        case three_BTN:
           strcat(pwBuf,"3");
           break;
        case four_BTN:
           strcat(pwBuf,"4");
           break;
        case five_BTN:
           strcat(pwBuf,"5");
           break;
        case six_BTN:
           strcat(pwBuf,"6");
           break;
        case seven_BTN:
           strcat(pwBuf,"7");
           break;
        case eight_BTN:
           strcat(pwBuf,"8");
           break;
        case nine_BTN:                           
           strcat(pwBuf,"9");
           break;
        case zero_BTN:                           
           strcat(pwBuf,"0");
           break;
        case backspace_BTN:
           bsFlag=TRUE;
           break;
        case ok_BTN:
           okFlag=TRUE;
           break;
      }
      if(!okFlag)
      {
         if(!bsFlag)
         {
           event->eType=keyDownEvent;
           event->ch='*';
           event->data1=0;
           if(col<10)
              col++;
           EvtAddEventToQueue(event,error);
         }
         else
         {
           event->eType=keyDownEvent;
           event->ch=BACKSPACE;
           event->data1=0;
           EvtAddEventToQueue(event,error);
           if(col<1)
              col--;
           pwBuf[col-2]='\0';
              
         } 
      }
      return(TRUE);
   }
}


/***************************************
*    password_FRMok_BTNHandler
***************************************/

BOOLEAN password_FRMok_BTNHandler(EVENTTYPE *event, WORD *error)
{
	BOOLEAN handled = FALSE;
	char* stringPtr;
	*error = eMsOK;

	switch (event->eType)
	{
		case ctlExitEvent:
		{
			InitForm(test_FRM);
			*error = GetErrorCode();
			if (*error)
				return(handled);
			stringPtr = GetFieldString(password_FRM, password_FLD);
			*error = GetErrorCode();
			if (*error)
				return(handled);
			SetFieldString(test_FRM, password_FLD, stringPtr);
			*error = GetErrorCode();
			if (*error)
				return(handled);
			GotoForm(test_FRM);
			break;
		}
	}

	return handled;
}

/***************************************
*    password_FRMHandler
***************************************/

BOOLEAN password_FRMHandler(EVENTTYPE *event, WORD *error)
{
	BOOLEAN handled = FALSE;
	*error = eMsOK;

	switch (event->eType)
	{
		case ctlExitEvent:
		{
			handled=HandPasswordEntry(event,error);
			break;
		}
	}

	return handled;
}

/*****************************************
*    password_FRMHandleEvent
*****************************************/

BOOLEAN password_FRMHandleEvent(EVENTTYPE *event, WORD *error)
{
	BOOLEAN handled = FALSE;
	*error = eMsOK;

	switch (GetObjectId(event))
	{
		case ok_BTN:
		{
			handled = password_FRMok_BTNHandler(event, error);
			break;
		}
	}

	if (!handled)
	{
		handled = password_FRMHandler(event, error);
	}

	return handled;
}

/***************************************
*    test_FRMexit_BTNHandler
***************************************/

BOOLEAN test_FRMexit_BTNHandler(EVENTTYPE *event, WORD *error)
{
	BOOLEAN handled = FALSE;
	*error = eMsOK;

	switch (event->eType)
	{
		case ctlExitEvent:
		{
			Stop();
			break;
		}
	}

	return handled;
}

/***************************************
*    test_FRMHandler
***************************************/

BOOLEAN test_FRMHandler(EVENTTYPE *event, WORD *error)
{
	BOOLEAN handled = FALSE;
	*error = eMsOK;

	switch (event->eType)
	{
		case winEnterEvent:
		{
			{
			    char tmpBuf[80]; 
			    sprintf(tmpBuf,"Contents of pwBuf: %s", pwBuf);
			    DisplayNotice(tmpBuf,"OK","");
			  }
			break;
		}
	}

	return handled;
}

/*****************************************
*    test_FRMHandleEvent
*****************************************/

BOOLEAN test_FRMHandleEvent(EVENTTYPE *event, WORD *error)
{
	BOOLEAN handled = FALSE;
	*error = eMsOK;

	switch (GetObjectId(event))
	{
		case exit_BTN:
		{
			handled = test_FRMexit_BTNHandler(event, error);
			break;
		}
	}

	if (!handled)
	{
		handled = test_FRMHandler(event, error);
	}

	return handled;
}

/***************************************
*    CurrentFormHandleEvent
***************************************/

BOOLEAN CurrentFormHandleEvent(EVENTTYPE *event, WORD *error)
{
	BOOLEAN handled = FALSE;
	*error = eMsOK;

	switch (GetEventsObject(event))
	{
		case password_FRM:
		{
			handled = password_FRMHandleEvent(event, error);
			break;
		}
		case test_FRM:
		{
			handled = test_FRMHandleEvent(event, error);
			break;
		}
	}

	return handled;
}

/***************************************
*    ApplicationHandleEvent
***************************************/

BOOLEAN ApplicationHandleEvent(EVENTTYPE *event, WORD *error)
{
	BOOLEAN handled = FALSE;
	*error = eMsOK;

	switch (event->eType)
	{
		case appEnterEvent:
		{
			memset(pwBuf,'\0',FIELDSIZE);
			GotoForm(password_FRM);
			break;
		}
	}

	return handled;
}

